//
//  TasksText.swift
//  SoundCloudClientApp
//
//  Created by Aleksandr Aniskin on 03.10.2021.
//

// @VladislavPischykov GitLab: pischykov

// MARK:     Детали реализации экранов:

// MARK:     Логин / Авторизация:
//      Поля ввода логина и пароля соответственно, кнопка Login, которая становится рабочей, когда в обоих полях есть хотя бы по одному символу. При неудачном логине (неправильный логин и/или пароль) показать нативный алерт.
//      Полученный в случае успешного логина токен сохранить в безопасном хранилище и при входе в приложение проверять на его наличие, чтобы в случае, если пользователь успешно залогинился ранее, пропускать авторизацию и сразу показывать ему следующий экран.
//      Регистрация - опционально.
//      На начальном этапе имеет смысл опустить реализацию сетевых запросов и логиниться при помощи предустановленных данных.

// MARK:     Список треков с поиском:
//      Поисковая строка, ниже - таблица cо списком результатов поиска. Если поисковая строка пустая или результат поиска пустой - показать заглушку с текстом посередине экрана.
//      В ячейке с песней отображается обложка альбома, имя автора и название песни / трека
//      У каждой песни должна быть возможность воспроизвести ее - нажать на ячейку, и возможность добавить \ удалить в избранное - кнопка внутри ячейки справа.
//      При воспроизведении песни внизу экрана появляется плашка с плеером - дочерний контроллер с информацией о треке, аналогичной той, что есть в ячейке, плюс возможность управлять воспроизведением - кнопка play / pause.
//      В плейлист, помимо текущего выбранного, добавляются все следующие за ним треки.
//      При нажатии на плашку с плеером она раскрывается и показывает дочерний контроллер плеера модально.
//      На начальном этапе имеет смысл опустить реализацию сетевых запросов и показывать предустановленный список треков.

// MARK:     Плеер:
//      Обложка трека, текущая продолжительность воспроизведения, длительность трека, прогрессбар с возможностью перемотки трека, кнопки плей / следующий / предыдущий, обложка трека, автор и название.
//      Возможность отсюда добавить трек в избранное аналогично экрану с поиском.
//      Два режима отображения - плашкой внизу экрана и полноценный экран модально.
//      При сворачивании из модального состояния плеер не должен закрываться, плейлист сохраняется и воспроизведение продолжается.

//      *Задание со звездочкой: реализовать модель данных плейлиста как кастомную коллекцию, с возможностью включить и выключить режим случайного воспроизведения - при включенном случайном режиме треки внутри плейлиста перемешиваются, при выключенном - возвращаются в исходном порядке.
